woocommerce
/
includes
/
rest-api
/
Controllers
/
Version2
/
class-wc-rest-webhook-deliveries-v2-controller.php
class-wc-rest-coupons-v2-controller.php
2 months ago
class-wc-rest-customer-downloads-v2-controller.php
5 years ago
class-wc-rest-customers-v2-controller.php
2 months ago
class-wc-rest-network-orders-v2-controller.php
1 year ago
class-wc-rest-order-notes-v2-controller.php
5 years ago
class-wc-rest-order-refunds-v2-controller.php
2 months ago
class-wc-rest-orders-v2-controller.php
1 month ago
class-wc-rest-payment-gateways-v2-controller.php
11 months ago
class-wc-rest-product-attribute-terms-v2-controller.php
5 years ago
class-wc-rest-product-attributes-v2-controller.php
5 years ago
class-wc-rest-product-brands-v2-controller.php
1 year ago
class-wc-rest-product-categories-v2-controller.php
3 months ago
class-wc-rest-product-reviews-v2-controller.php
4 years ago
class-wc-rest-product-shipping-classes-v2-controller.php
5 years ago
class-wc-rest-product-tags-v2-controller.php
5 years ago
class-wc-rest-product-variations-v2-controller.php
2 months ago
class-wc-rest-products-v2-controller.php
2 months ago
class-wc-rest-report-sales-v2-controller.php
5 years ago
class-wc-rest-report-top-sellers-v2-controller.php
5 years ago
class-wc-rest-reports-v2-controller.php
5 years ago
class-wc-rest-setting-options-v2-controller.php
2 months ago
class-wc-rest-settings-v2-controller.php
5 years ago
class-wc-rest-shipping-methods-v2-controller.php
1 year ago
class-wc-rest-shipping-zone-locations-v2-controller.php
1 year ago
class-wc-rest-shipping-zone-methods-v2-controller.php
1 year ago
class-wc-rest-shipping-zones-v2-controller.php
1 month ago
class-wc-rest-system-status-tools-v2-controller.php
1 month ago
class-wc-rest-system-status-v2-controller.php
1 month ago
class-wc-rest-tax-classes-v2-controller.php
1 year ago
class-wc-rest-taxes-v2-controller.php
5 years ago
class-wc-rest-webhook-deliveries-v2-controller.php
5 years ago
class-wc-rest-webhooks-v2-controller.php
1 year ago
class-wc-rest-webhook-deliveries-v2-controller.php
154 lines
| 1 | <?php |
| 2 | /** |
| 3 | * REST API Webhooks controller |
| 4 | * |
| 5 | * Handles requests to the /webhooks/<webhook_id>/deliveries endpoint. |
| 6 | * |
| 7 | * @package WooCommerce\RestApi |
| 8 | * @since 2.6.0 |
| 9 | */ |
| 10 | |
| 11 | defined( 'ABSPATH' ) || exit; |
| 12 | |
| 13 | /** |
| 14 | * REST API Webhook Deliveries controller class. |
| 15 | * |
| 16 | * @deprecated 3.3.0 Webhooks deliveries logs now uses logging system. |
| 17 | * @package WooCommerce\RestApi |
| 18 | * @extends WC_REST_Webhook_Deliveries_V1_Controller |
| 19 | */ |
| 20 | class WC_REST_Webhook_Deliveries_V2_Controller extends WC_REST_Webhook_Deliveries_V1_Controller { |
| 21 | |
| 22 | /** |
| 23 | * Endpoint namespace. |
| 24 | * |
| 25 | * @var string |
| 26 | */ |
| 27 | protected $namespace = 'wc/v2'; |
| 28 | |
| 29 | /** |
| 30 | * Prepare a single webhook delivery output for response. |
| 31 | * |
| 32 | * @param stdClass $log Delivery log object. |
| 33 | * @param WP_REST_Request $request Request object. |
| 34 | * @return WP_REST_Response |
| 35 | */ |
| 36 | public function prepare_item_for_response( $log, $request ) { |
| 37 | $data = (array) $log; |
| 38 | |
| 39 | $context = ! empty( $request['context'] ) ? $request['context'] : 'view'; |
| 40 | $data = $this->add_additional_fields_to_object( $data, $request ); |
| 41 | $data = $this->filter_response_by_context( $data, $context ); |
| 42 | |
| 43 | // Wrap the data in a response object. |
| 44 | $response = rest_ensure_response( $data ); |
| 45 | |
| 46 | $response->add_links( $this->prepare_links( $log ) ); |
| 47 | |
| 48 | /** |
| 49 | * Filter webhook delivery object returned from the REST API. |
| 50 | * |
| 51 | * @param WP_REST_Response $response The response object. |
| 52 | * @param stdClass $log Delivery log object used to create response. |
| 53 | * @param WP_REST_Request $request Request object. |
| 54 | */ |
| 55 | return apply_filters( 'woocommerce_rest_prepare_webhook_delivery', $response, $log, $request ); |
| 56 | } |
| 57 | |
| 58 | /** |
| 59 | * Get the Webhook's schema, conforming to JSON Schema. |
| 60 | * |
| 61 | * @return array |
| 62 | */ |
| 63 | public function get_item_schema() { |
| 64 | $schema = array( |
| 65 | '$schema' => 'http://json-schema.org/draft-04/schema#', |
| 66 | 'title' => 'webhook_delivery', |
| 67 | 'type' => 'object', |
| 68 | 'properties' => array( |
| 69 | 'id' => array( |
| 70 | 'description' => __( 'Unique identifier for the resource.', 'woocommerce' ), |
| 71 | 'type' => 'integer', |
| 72 | 'context' => array( 'view' ), |
| 73 | 'readonly' => true, |
| 74 | ), |
| 75 | 'duration' => array( |
| 76 | 'description' => __( 'The delivery duration, in seconds.', 'woocommerce' ), |
| 77 | 'type' => 'string', |
| 78 | 'context' => array( 'view' ), |
| 79 | 'readonly' => true, |
| 80 | ), |
| 81 | 'summary' => array( |
| 82 | 'description' => __( 'A friendly summary of the response including the HTTP response code, message, and body.', 'woocommerce' ), |
| 83 | 'type' => 'string', |
| 84 | 'context' => array( 'view' ), |
| 85 | 'readonly' => true, |
| 86 | ), |
| 87 | 'request_url' => array( |
| 88 | 'description' => __( 'The URL where the webhook was delivered.', 'woocommerce' ), |
| 89 | 'type' => 'string', |
| 90 | 'format' => 'uri', |
| 91 | 'context' => array( 'view' ), |
| 92 | 'readonly' => true, |
| 93 | ), |
| 94 | 'request_headers' => array( |
| 95 | 'description' => __( 'Request headers.', 'woocommerce' ), |
| 96 | 'type' => 'array', |
| 97 | 'context' => array( 'view' ), |
| 98 | 'readonly' => true, |
| 99 | 'items' => array( |
| 100 | 'type' => 'string', |
| 101 | ), |
| 102 | ), |
| 103 | 'request_body' => array( |
| 104 | 'description' => __( 'Request body.', 'woocommerce' ), |
| 105 | 'type' => 'string', |
| 106 | 'context' => array( 'view' ), |
| 107 | 'readonly' => true, |
| 108 | ), |
| 109 | 'response_code' => array( |
| 110 | 'description' => __( 'The HTTP response code from the receiving server.', 'woocommerce' ), |
| 111 | 'type' => 'string', |
| 112 | 'context' => array( 'view' ), |
| 113 | 'readonly' => true, |
| 114 | ), |
| 115 | 'response_message' => array( |
| 116 | 'description' => __( 'The HTTP response message from the receiving server.', 'woocommerce' ), |
| 117 | 'type' => 'string', |
| 118 | 'context' => array( 'view' ), |
| 119 | 'readonly' => true, |
| 120 | ), |
| 121 | 'response_headers' => array( |
| 122 | 'description' => __( 'Array of the response headers from the receiving server.', 'woocommerce' ), |
| 123 | 'type' => 'array', |
| 124 | 'context' => array( 'view' ), |
| 125 | 'readonly' => true, |
| 126 | 'items' => array( |
| 127 | 'type' => 'string', |
| 128 | ), |
| 129 | ), |
| 130 | 'response_body' => array( |
| 131 | 'description' => __( 'The response body from the receiving server.', 'woocommerce' ), |
| 132 | 'type' => 'string', |
| 133 | 'context' => array( 'view' ), |
| 134 | 'readonly' => true, |
| 135 | ), |
| 136 | 'date_created' => array( |
| 137 | 'description' => __( "The date the webhook delivery was logged, in the site's timezone.", 'woocommerce' ), |
| 138 | 'type' => 'date-time', |
| 139 | 'context' => array( 'view', 'edit' ), |
| 140 | 'readonly' => true, |
| 141 | ), |
| 142 | 'date_created_gmt' => array( |
| 143 | 'description' => __( 'The date the webhook delivery was logged, as GMT.', 'woocommerce' ), |
| 144 | 'type' => 'date-time', |
| 145 | 'context' => array( 'view', 'edit' ), |
| 146 | 'readonly' => true, |
| 147 | ), |
| 148 | ), |
| 149 | ); |
| 150 | |
| 151 | return $this->add_additional_fields_schema( $schema ); |
| 152 | } |
| 153 | } |
| 154 |